import { getRndInteger } from '../../utils/utils.js'
import { getOssPermission } from '../../api/request.js'
import { saveFileInfo, getMeetingRoomAffairs, createMeetingTask, deleteMeetingTask, updateMeetingTask, uploadPermissions } from '../../api/request';
import pageStore from './store'

// 选择图片
function getImg() {
    return new Promise((resolve, rejects) => {
        dd.chooseImage({
            count: 1,
            success: (res) => {
                resolve(res)
            },
            fail: (err) => {
                rejects({ code: -1, ...err })
            }
        });
    })
}

// 获取的图片上传到oss
async function uploadImg(imgInfo) {
    const permisson = await getOssPermission()
    const timestamp = new Date().getTime()
    const random = getRndInteger(1000, 10000)
    const fileName = timestamp.toString() + random.toString() + '.' + imgInfo.files[0].fileType;
    const key = permisson.data.data.dir + fileName;
    return new Promise((resolve, rejects) => {
        dd.uploadFile({
            url: permisson.data.data.host,
            fileType: 'image',
            fileName: 'file',
            filePath: imgInfo.filePaths[0],
            formData: {
                key: key,
                policy: permisson.data.data.policy,
                OSSAccessKeyId: permisson.data.data.accessId,
                success_action_status: 200,
                signature: permisson.data.data.signature
            },
            success: (res) => {
                console.log(JSON.stringify(res))
                resolve([{
                    fileId: key,
                    fileName: fileName,
                    fileType: imgInfo.files[0].fileType,
                    fileSize: imgInfo.files[0].size
                }])
            },
            fail: (err) => {
                rejects({ code: -1, ...err })
            }
        })
    })
}
// 从OSS获取fileInfo
export async function getFileInfoFromOss() {
    // 选择图片
    const imgInfo = await getImg()
    if (imgInfo.code === -1) {
        return { code: -1, msg: '选择图片失败' }
    }
    // 上传图片
    const fileInfo = await uploadImg(imgInfo)
    if (fileInfo.code === -1) {
        return { code: -1, msg: '选上传图片失败' }
    }

    // 返回fileInfo
    return { code: 0, msg: 'success', data: fileInfo }
}